//+------------------------------------------------------------------+
//|                                                 Spread_i_Env.mq5 |
//|                                                         olyakish |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "olyakish"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 6 
#property indicator_plots   4

#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Label2
#property indicator_label2  "Label2"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Label3
#property indicator_label3  "Label3"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrRed
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1

input string Symbol_name1="XAGUSD";
input string Symbol_name2="XAUUSD";
input int Symbol_Vol1=1;
input int Symbol_Vol2=2;

input int history=500; //    
input int               ENPeriod    =  21;
input ENUM_MA_METHOD    ENMethod    =  MODE_SMA;
input double            ENDeviation =  0.5;
//--- indicator buffers
double         UBuffer[];
double         LBuffer[];
double         CBuffer[];
#include <IncOnArray/IncEnvelopesOnArray.mqh>
CEnvelopesOnArray en;

double last[],closeSymbol1[],closeSymbol2[];
double Symbol1_K,Symbol2_K;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {

   en.Init(ENPeriod,ENMethod,ENDeviation);

   SetIndexBuffer(0,UBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,LBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,CBuffer,INDICATOR_DATA);

   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,en.BarsRequired());
   PlotIndexSetString(0,PLOT_LABEL,en.Name()+" Upper");

   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,en.BarsRequired());
   PlotIndexSetString(1,PLOT_LABEL,en.Name()+" Lower");

   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,en.BarsRequired());
   PlotIndexSetString(2,PLOT_LABEL,en.Name()+" MA");

   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,history);                   //   
   PlotIndexSetInteger(3,PLOT_LINE_COLOR,clrTomato);          //       
   PlotIndexSetInteger(3,PLOT_DRAW_TYPE,DRAW_LINE);              //   ()     
   SetIndexBuffer(3,last,INDICATOR_DATA);                    //   
   SetIndexBuffer(4,closeSymbol1,INDICATOR_CALCULATIONS);                    // 
   SetIndexBuffer(5,closeSymbol2,INDICATOR_CALCULATIONS);                    //  


   Symbol1_K = SymbolInfoDouble(Symbol_name1, SYMBOL_TRADE_TICK_VALUE_PROFIT)/SymbolInfoDouble(Symbol_name1,SYMBOL_TRADE_TICK_SIZE);
   Symbol2_K = SymbolInfoDouble(Symbol_name2, SYMBOL_TRADE_TICK_VALUE_PROFIT)/SymbolInfoDouble(Symbol_name2,SYMBOL_TRADE_TICK_SIZE);
   Symbol1_K=5000;    //     AlpariFS-MT5
   Symbol2_K=100;     //     AlpariFS-MT5

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &Time[],
                const double &Open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &TickVolume[],
                const long &Volume[],
                const int &Spread[])
  {
   int countCopy=-1;
   datetime time0Symbol1[2],time0Symbol2[2],timePrevSymbol1,timePrevSymbol2;
   CopyTime(Symbol_name1,PERIOD_CURRENT,0,2,time0Symbol1);
   CopyTime(Symbol_name2,PERIOD_CURRENT,0,2,time0Symbol2);
Comment(Symbol1_K,"\n",Symbol2_K,"\n",DoubleToString(SymbolInfoDouble(Symbol_name1,SYMBOL_TRADE_TICK_SIZE),7),"\n",SymbolInfoDouble(Symbol_name1,SYMBOL_TRADE_TICK_VALUE_PROFIT));
   int needcountCopy=history;
   if(time0Symbol1[1]==time0Symbol2[1] && time0Symbol1[0]==timePrevSymbol1 && time0Symbol2[0]==timePrevSymbol2){needcountCopy=1;}
   if(time0Symbol1[1]==time0Symbol2[1]) //   
     {
      countCopy=CopyClose(Symbol_name1,PERIOD_CURRENT,0,needcountCopy,closeSymbol1);
      countCopy=CopyClose(Symbol_name2,PERIOD_CURRENT,0,needcountCopy,closeSymbol2);
      timePrevSymbol1=time0Symbol1[0];
      timePrevSymbol2=time0Symbol2[0];
     }

   for(int i=rates_total-1;i>=rates_total-needcountCopy;i--)
     {
      last[i]=Symbol_Vol1*Symbol1_K*closeSymbol1[i]-Symbol_Vol2*Symbol2_K*closeSymbol2[i];
     }
   en.Solve(rates_total,0,last,CBuffer,LBuffer,UBuffer);//     UBuffer  LBuffer  

   if(last[rates_total-2]>last[rates_total-3] && last[rates_total-3]<LBuffer[rates_total-3]){GlobalVariableSet("trade",2.0);}
   if(last[rates_total-2]<last[rates_total-3] && last[rates_total-3]>UBuffer[rates_total-3]){GlobalVariableSet("trade",-2.0);}
   if((last[rates_total-2]<UBuffer[rates_total-2] && last[rates_total-3]<UBuffer[rates_total-3] && 
      last[rates_total-2]>LBuffer[rates_total-2] && last[rates_total-3]>LBuffer[rates_total-3])
      //|| (last[rates_total-2]<last[rates_total-3] && last[rates_total-3]<LBuffer[rates_total-3])
      //|| (last[rates_total-2]>last[rates_total-3] && last[rates_total-3]>UBuffer[rates_total-3])
      )
     {GlobalVariableSet("trade",0.0);}

   return(rates_total);
  }
//+------------------------------------------------------------------+
